/** Carpent question (inquirer) type */
export interface CarpentQuestion {
    name: string;
    type: "checkbox" | "confirm" | "editor" | "expand" | "input" | "list" | "number" | "password" | "rawlist";
    message: string;
    default?: string;
    choices?: string[];
    files?: string[];
    jsonKey?: string;
    find?: string;
    replace?: string;
}
/** Carpent configuration object type */
export interface CarpentConfig {
    deleteFiles?: string[];
    questions?: CarpentQuestion[];
    beforeAll?: string[];
    afterAll?: string[];
}
/**
 * Bootstrap a new project with Carpent
 * @param defaultAnswers - Object containing values
 */
export declare const carpent: (defaultAnswers?: {
    [index: string]: string;
}) => Promise<{
    path: string;
}>;
/**
 * Get the text for a license
 * @param SPDX - License SPDX identifier
 */
export declare const getLicenseText: (SPDX: string) => Promise<string>;
/** Licenses (SPDX to name map) */
export declare const LICENSES: {
    "Apache-2.0": string;
    "BSD-3-Clause": string;
    "CC-BY-SA-4.0": string;
    "GPL-3.0": string;
    MIT: string;
    UNLICENSED: string;
    "BSD-2-Clause": string;
    "CC-BY-4.0": string;
    "CC0-1.0": string;
    ISC: string;
    "MPL-2.0": string;
    Unlicense: string;
};
